DAT programName         byte "CheapBotFigure8_130204b", 0
robotName               byte "Cheap Bot", 0
CON
{{
  
  Use this program drives the Cheap Bot in a Figure 8
  pattern.


}}
{
  02f drives about 5/8 of a circle
  02h Appears to perform a figure 8 reasonably well.
  02i Ramping seems to work okay.
  02j Shape of figure 8 is very dependent on the charge state of the batteries.
  Rename program to CheapBotFigure8_130204a
  4a Use 5V regulator to keep servo voltage constant.
  Using four Li Ion AA 1200mAh cells in battery pack.
  4a Circle about 1/8 too large.
  
}
CON

  _Clkmode = xtal1 + pll16x                           
  _Xinfreq = 5_000_000
   
  ' pin assignments
  STARBOARD_PIN = 16
  PORT_PIN = 17

  STOP = 1500             ' us
  
  REFRESH_RATE = 50

  STEPS_PER_FIGURE = 1150 '23 * REFRESH_RATE   ' 23 < ? < 24  with ramping

  DEFAULT_SPEED = 100
  DEFAULT_TURN_RATE = DEFAULT_SPEED / 4
  DEFAULT_ACCELERATION = 1 '10

  BAUD = 115200
  PSEUDOREAL_MULTIPLIER = 100

  TOTAL_WHEELS = 2
  
  #0, PORT, STARBOARD

  ' newDataType enumeration
  #0, NO_NEW_DATA, RAMPING_TURN_NEW_DATA, RAMPING_STRAIGHT_NEW_DATA, END_PROGRAM_NEW_DATA

  ' debugFlag enumeration
  #0, NO_DEBUG, RAMP_DEBUG
                                      
CON

  TITLE_X = 3                   ' location for title
  TITLE_Y = 3
  DISPLAY_X = TITLE_X              
  DISPLAY_Y = TITLE_Y + 3
  TARGET_SPEED_X = DISPLAY_X 
  TARGET_SPEED_Y = DISPLAY_Y 

  CURRENT_SPEED_X = TARGET_SPEED_X
  CURRENT_SPEED_Y = TARGET_SPEED_Y + 4
  {ENCODER_X = CURRENT_SPEED_X
  ENCODER_Y = CURRENT_SPEED_Y + 6
  PIN_STATES_X = ENCODER_X
  PIN_STATES_Y = ENCODER_Y + 6  
  OLD_INFO_X = PIN_STATES_X
  OLD_INFO_Y = PIN_STATES_Y + 3
  REQUEST_INPUT_X = OLD_INFO_X 
  REQUEST_INPUT_Y = OLD_INFO_Y + 2  }
  NEW_INFO_X = CURRENT_SPEED_X ' REQUEST_INPUT_X
  NEW_INFO_Y = CURRENT_SPEED_Y + 12 'REQUEST_INPUT_Y + 2

  DEBUG_X = NEW_INFO_X
  DEBUG_Y = NEW_INFO_Y + 4
  
  {PID_X = DISPLAY_X
  PID_Y = DISPLAY_Y + 9
  ADJUSTED_PID_X = PID_X
  ADJUSTED_PID_Y = PID_Y + 4
  }
  NEW_DATA_DISPLAY_TIME = 10    ' Keep this less than half the rollover time. 
  'PARAMETERS_TO_DISPLAY = 7

VAR

  long nextRefreshTime, refreshInterval
  long pulseLength[TOTAL_WHEELS], loopCount, previousLoopCount
  long debugStack[100]
  long currentSpeed[TOTAL_WHEELS], pPulseLength[TOTAL_WHEELS], fPulseLength[TOTAL_WHEELS]
  long targetSpeed[TOTAL_WHEELS], pTargetSpeed[TOTAL_WHEELS], fTargetSpeed[TOTAL_WHEELS]
  long newDataInterval, newDataTimer
  long debugValue[10], debugString[10]
  long dAccel[TOTAL_WHEELS], pseudoCurrentSpeed[TOTAL_WHEELS]
  long globalRampingSteps, pRampingSteps 
  byte rampFlag, newDataType, debugFlag, debugParameters
  byte pDebugFlag
  
  
OBJ

  Servo : "Servo32v7.spin"
  Pst : "Parallax Serial Terminal"
  
PUB Setup | temp

  refreshInterval := clkfreq /  REFRESH_RATE
  previousLoopCount := -1
  newDataType := NO_NEW_DATA
  newDataInterval := clkfreq * NEW_DATA_DISPLAY_TIME
  'longfill(@pTargetSpeed, -1, TOTAL_WHEELS)
  'longfill(@pPulseLength, -1, TOTAL_WHEELS)
  pDebugFlag := debugFlag
  debugFlag := 0
  debugParameters := 0
  rampFlag := 1
  'waitcnt(clkfreq * 2 + cnt)
  
  cognew(DebugCog, @debugStack)
  Servo.Start                 'Start Servo handler
  
  waitcnt(clkfreq / 10 + cnt) ' Give time for cog to launch
  nextRefreshTime := cnt + refreshInterval 
  SetSpeedStraight(0)
  'repeat
  
  'waitcnt(clkfreq / 2 + cnt) 
 

  MainLoop
  
PUB MainLoop | localIndex, turnRate, speed

  localIndex := STEPS_PER_FIGURE / 2
  turnRate := DEFAULT_TURN_RATE ' start turning to port
  speed := DEFAULT_SPEED
  nextRefreshTime := cnt + refreshInterval

  'rampFlag := 1
  SetSpeedStraight(speed)
 
    
  'rampFlag := 1
  repeat localIndex 
    SetSpeedTurn(speed, turnRate)
      
  'rampFlag := 1
  'Ramp(speed, speed)

  newDataType := END_PROGRAM_NEW_DATA

  'SetSpeedStraight(speed)
  'repeat 10
  '  Refresh
  'repeat
    'newDataTimer := cnt
    
  -turnRate
  'rampFlag := 1
  
  repeat localIndex 
    SetSpeedTurn(speed, turnRate)
  
  'rampFlag := 1
  SetSpeedStraight(0)  
 
  repeat ' keep program from ending

PRI SetSpeedStraight(localSpeed)

  'Pst.Position(DEBUG_X, DEBUG_Y)
  'Pst.Str(string("SetSpeedStraight Method"))
 {longfill(@targetSpeed, localSpeed, TOTAL_WHEELS)}
  if rampFlag
    'newDataTimer := cnt
    'newDataType := RAMPING_STRAIGHT_NEW_DATA
    if ||(currentSpeed[PORT] - localSpeed) > DEFAULT_ACCELERATION or {
     } ||(currentSpeed[STARBOARD] - localSpeed) > DEFAULT_ACCELERATION
      result := Ramp(localSpeed, localSpeed)  
  'longfill(@currentSpeed, localSpeed, TOTAL_WHEELS)
  'Pst.Position(DEBUG_X, DEBUG_Y + 1)
  'Pst.ClearEnd
  pDebugFlag := debugFlag
  debugFlag := 1
  pulseLength[PORT] := STOP + localSpeed    
  pulseLength[STARBOARD] := STOP - localSpeed
  Refresh
  result++
  
PRI SetSpeedTurn(localSpeed, turnAmount)
'' A positive turn is counter clockwise.
  'Pst.Position(DEBUG_X, DEBUG_Y)
  'Pst.Str(string("SetSpeedTurn Method"))
  targetSpeed[PORT] := localSpeed - turnAmount
  targetSpeed[STARBOARD] := localSpeed + turnAmount
  if rampFlag
    'newDataTimer := cnt
    'newDataType := RAMPING_STRAIGHT_NEW_DATA
    if ||(currentSpeed[PORT] - targetSpeed[PORT]) > DEFAULT_ACCELERATION or {
     } ||(currentSpeed[STARBOARD] - targetSpeed[STARBOARD]) > DEFAULT_ACCELERATION
      result := Ramp(targetSpeed[PORT], targetSpeed[STARBOARD])
 ' Pst.Position(DEBUG_X, DEBUG_Y + 1)
  'Pst.ClearEnd
  'currentSpeed[PORT] := targetSpeed[PORT]
  'currentSpeed[STARBOARD] := targetSpeed[STARBOARD]
  pDebugFlag := debugFlag
  debugFlag := 2
  pulseLength[PORT] := STOP + targetSpeed[PORT]  
  pulseLength[STARBOARD] := STOP - targetSpeed[STARBOARD]
  Refresh
  result++
  
PRI Refresh

  waitcnt(nextRefreshTime)
  nextRefreshTime += refreshInterval
  Servo.Set(PORT_PIN, pulseLength[PORT])
  Servo.Set(STARBOARD_PIN, pulseLength[STARBOARD])    
  currentSpeed[PORT] := pulseLength[PORT] - STOP
  currentSpeed[STARBOARD] := -1 * (pulseLength[STARBOARD] - STOP)
  loopCount++
  
PRI Ramp(finalSpeedPort, finalSpeedStarboard) : rampingSteps | localAccel[2], maxAccel', {
'  } localSpeed[2] 
'' A positive turn is counter clockwise.
  'Pst.Position(DEBUG_X, DEBUG_Y + 1)
  'Pst.Str(string("Ramp Method"))
  pDebugFlag := debugFlag
  debugFlag := 3
  maxAccel := DEFAULT_ACCELERATION * PSEUDOREAL_MULTIPLIER
  'currentSpeed[PORT] := pulseLength[PORT] - STOP
  'currentSpeed[STARBOARD] := -pulseLength[STARBOARD] + STOP
  localAccel[PORT] := (finalSpeedPort - currentSpeed[PORT]) * PSEUDOREAL_MULTIPLIER
  localAccel[STARBOARD] := (finalSpeedStarboard - currentSpeed[STARBOARD]) * PSEUDOREAL_MULTIPLIER
  'localSpeed[PORT] := currentSpeed[PORT] * PSEUDOREAL_MULTIPLIER
  'localSpeed[STARBOARD] := currentSpeed[STARBOARD] * PSEUDOREAL_MULTIPLIER
  
  if ||localAccel[PORT] > ||localAccel[STARBOARD]
    localAccel[STARBOARD] := (localAccel[STARBOARD] * maxAccel ) / ||localAccel[PORT] 
    rampingSteps := ||(localAccel[PORT] / maxAccel)
    if localAccel[PORT] < 0
      localAccel[PORT] := -maxAccel
    else
      localAccel[PORT] := maxAccel
  else
    localAccel[PORT] := (localAccel[PORT] / ||localAccel[STARBOARD]) * maxAccel
    rampingSteps := ||(localAccel[STARBOARD] / maxAccel)
    if localAccel[STARBOARD] < 0
      localAccel[STARBOARD] := -maxAccel
    else
      localAccel[STARBOARD] := maxAccel
  {debugParameters := 3
  debugString[0] := string("rampingSteps = ")
  debugValue[0] := rampingSteps
  debugString[1] := string("localAccel[PORT] = ")
  debugValue[1] := localAccel[PORT]
  debugString[2] := string("localAccel[STARBOARD] = ")
  debugValue[2] := localAccel[STARBOARD]          }
  dAccel[PORT] := localAccel[PORT]    
  dAccel[STARBOARD] := localAccel[STARBOARD]
  pseudoCurrentSpeed[PORT] := currentSpeed[PORT] * PSEUDOREAL_MULTIPLIER  
  pseudoCurrentSpeed[STARBOARD] := currentSpeed[STARBOARD] * PSEUDOREAL_MULTIPLIER
  pRampingSteps := globalRampingSteps
  globalRampingSteps := rampingSteps
  repeat rampingSteps
    pseudoCurrentSpeed[PORT] += localAccel[PORT]
    pseudoCurrentSpeed[STARBOARD] += localAccel[STARBOARD]
    pulseLength[PORT] := STOP + (pseudoCurrentSpeed[PORT] / PSEUDOREAL_MULTIPLIER) 
    pulseLength[STARBOARD] := STOP - (pseudoCurrentSpeed[STARBOARD] / PSEUDOREAL_MULTIPLIER) 
    Refresh
    'newDataTimer := cnt
    
  'rampFlag := 0
  
PUB DebugCog

  Pst.Start(BAUD)
  Pst.Clear
  Pst.Position(TITLE_X, TITLE_Y)
  Pst.Str(string("Cheap Bot Demo"))
  'waitcnt(clkfreq / 2 + cnt)
  repeat
    repeat
      result := loopCount
    while result == previousLoopCount
    previousLoopCount := result
    
    'CheckNewData
    DisplayTargetSpeed
    DisplayPulseLength
    'DisplayDebug
    DisplayNewData
    
PRI DisplayDebug

  ifnot debugParameters
    Pst.Position(DEBUG_X, DEBUG_Y)
    Pst.ClearEnd
    Pst.ClearBelow
    return
  repeat result from 0 to debugParameters - 1
    Pst.Position(DEBUG_X, DEBUG_Y + result)
    Pst.Str(debugString[result])
    Pst.Dec(debugValue[result])
    Pst.ClearEnd
  Pst.ClearBelow
   
PRI DisplayTargetSpeed

  Pst.Position(TARGET_SPEED_X, TARGET_SPEED_Y - 1)
  Pst.str(@textTSpeed)
  'waitcnt(clkfreq * 4 + cnt)
  longmove(@fTargetSpeed, @targetSpeed, TOTAL_WHEELS)
  repeat result from 0 to TOTAL_WHEELS - 1
    Pst.Position(TARGET_SPEED_X, TARGET_SPEED_Y + result)
    if fTargetSpeed[result] <> pTargetSpeed[result]
      Pst.str(string("targetSpeed["))
      Pst.dec(result)
      Pst.str(string("] = "))
      Pst.dec(fTargetSpeed[result])
      Pst.ClearEnd
      pTargetSpeed[result] := fTargetSpeed[result]
      
PRI DisplayPulseLength

  Pst.Position(CURRENT_SPEED_X, CURRENT_SPEED_Y - 1)
  Pst.str(@textCSpeed)
  'waitcnt(clkfreq * 4 + cnt)
  
  longmove(@fPulseLength, @pulseLength, TOTAL_WHEELS)
  repeat result from 0 to TOTAL_WHEELS - 1
    Pst.Position(CURRENT_SPEED_X, CURRENT_SPEED_Y + result)
    if fPulseLength[result] <> pPulseLength[result]
      Pst.str(string("pulseLength["))
      Pst.dec(result)
      Pst.str(string("] = "))
      Pst.dec(fPulseLength[result])
      Pst.ClearEnd
      pPulseLength[result] := fPulseLength[result]

  Pst.Position(CURRENT_SPEED_X, CURRENT_SPEED_Y + 4)
  Pst.str(string("dAccel[PORT] = "))
  Pst.dec(dAccel[PORT])
  Pst.ClearEnd
  Pst.Position(CURRENT_SPEED_X, CURRENT_SPEED_Y + 5)
  Pst.str(string("dAccel[STARBOARD] = "))
  Pst.dec(dAccel[STARBOARD])
  Pst.ClearEnd
  Pst.Position(CURRENT_SPEED_X, CURRENT_SPEED_Y + 6)
  Pst.str(string("pDebugFlag = "))
  Pst.dec(pDebugFlag)
  Pst.ClearEnd
  Pst.Position(CURRENT_SPEED_X, CURRENT_SPEED_Y + 7)
  Pst.str(string("debugFlag = "))
  Pst.dec(debugFlag)
  Pst.ClearEnd
  Pst.Position(CURRENT_SPEED_X, CURRENT_SPEED_Y + 8)
  Pst.str(string("pRampingSteps = "))
  Pst.dec(pRampingSteps)
  Pst.ClearEnd
  Pst.Position(CURRENT_SPEED_X, CURRENT_SPEED_Y + 9)
  Pst.str(string("globalRampingSteps = "))
  Pst.dec(globalRampingSteps)
  Pst.ClearEnd
  
      
PRI DisplayNewData
'' Last information displayed in terminal window.

  Pst.Position(NEW_INFO_X, NEW_INFO_Y)
  Pst.str(string("loopCount = "))
  Pst.dec(loopCount)
  {Pst.Position(NEW_INFO_X, NEW_INFO_Y + 1)
  
  case newDataType
    NO_NEW_DATA:
      Pst.ClearEnd
      Pst.ClearBelow
    RAMPING_TURN_NEW_DATA: 
      Pst.str(@newData0)
      Pst.ClearEnd
      Pst.ClearBelow
    RAMPING_STRAIGHT_NEW_DATA: 
      Pst.str(@newData1)
      Pst.ClearEnd
      Pst.ClearBelow
    END_PROGRAM_NEW_DATA:
      Pst.str(@newData2)
      Pst.ClearEnd
      Pst.ClearBelow      }
      
PRI CheckNewData

  if newDataType <> NO_NEW_DATA 
    if cnt - newDataInterval > newDataTimer
      newDataType := NO_NEW_DATA
      DisplayNewData
  
DAT

newData0      byte "Ramping Turn Speeds", 0
newData1      byte "Ramping Straight Speeds", 0
newData2      byte "End of Program", 0

textTSpeed    byte "Target Speeds:", 0

textCSpeed    byte "pulseLength:", 0

DAT '' License
{{
*********************************************************************************************
*                             TERMS OF USE: MIT License                                     *                                                                   
*********************************************************************************************
* Permission is hereby granted, free of charge, to any person obtaining a copy of this      *
* software and associated documentation files (the "Software"), to deal in the Software     *
* without restriction, including without limitation the rights to use, copy, modify,        *
* merge, publish, distribute, sublicense, and/or sell copies of the Software, and to        *
* permit persons to whom the Software is furnished to do so, subject to the following       *
* conditions:                                                                               *
*                                                                                           *                                    
* The above copyright notice and this permission notice shall be included in all copies or  *
* substantial portions of the Software.                                                     *
*                                                                                           *                                   
* The software is provided "as is", without warranty of any kind, express or implied,       *
* including but not limited to the warranties of merchantability, fitness for a particular  *
* and noninfringment. In no event shall the authors or copyright holders be liable for any  *
* claim, damages or other liability, whether in an action of contract, tort or otherwise,   *
* arising from, of or in connection with the software of the use of other dealings in the   *
* software.                                                                                 *
*********************************************************************************************
}}   